BORG-PRUNE(1)

NAME
borg-prune - Prune repository archives according to specified rules

SYNOPSIS

borg [common options] prune <options> REPOSITORY

DESCRIPTION

The prune command prunes a repository by deleting all archives not matching any of the specified retention options. This command is normally used by automated backup scripts wanting to keep a certain number of historic backups.

Also, prune automatically removes checkpoint archives (incomplete archives left behind by interrupted backup runs) except if the checkpoint is the latest archive (and thus still needed). Checkpoint archives are not considered when comparing archive counts against the retention limits (--keep-X).

If a prefix is set with -P, then only archives that start with the prefix are considered for deletion and only those archives count towards the totals specified by the rules. Otherwise, all archives in the repository are candidates for deletion! There is no automatic distinction between archives representing different contents. These need to be distinguished by specifying matching prefixes.

If you have multiple sequences of archives with different data sets (e.g. from different machines) in one shared repository, use one prune call per data set that matches only the respective archives using the -P option.

The "--keep-within" option takes an argument of the form "<int><char>", where char is "H", "d", "w", "m", "y". For example, "--keep-within 2d" means to keep all archives that were created within the past 48 hours. "1m" is taken to mean "31d". The archives kept with this option do not count towards the totals specified by any other options.

A good procedure is to thin out more and more the older your backups get. As an example, "--keep-daily 7" means to keep the latest backup on each day, up to 7 most recent days with backups (days without backups do not count). The rules are applied from secondly to yearly, and backups selected by previous rules do not count towards those of later rules. The time that each backup starts is used for pruning purposes. Dates and times are interpreted in the local timezone, and weeks go from Monday to Sunday. Specifying a negative number of archives to keep means that there is no limit.

The "--keep-last N" option is doing the same as "--keep-secondly N" (and it will keep the last N archives under the assumption that you do not create more than one backup archive in the same second).

OPTIONS

See borg-common(1) for common options of Borg commands.

  arguments

REPOSITORY
    repository to prune

  optional arguments

-n, --dry-run
    do not change repository

--force
    force pruning of corrupted archives

-s, --stats
    print statistics for the deleted archive

--list
    output verbose list of archives it keeps/prunes

--keep-within WITHIN
    keep all archives within this time interval

--keep-last, --keep-secondly
    number of secondly archives to keep

--keep-minutely
    number of minutely archives to keep

-H, --keep-hourly
    number of hourly archives to keep

-d, --keep-daily
    number of daily archives to keep

-w, --keep-weekly
    number of weekly archives to keep

-m, --keep-monthly
    number of monthly archives to keep

-y, --keep-yearly
    number of yearly archives to keep

-P, --prefix
    only consider archive names starting with this prefix

--save-space
    work slower, but using less space

EXAMPLES

Be careful, prune is a potentially dangerous command, it will remove backup archives.

The default of prune is to apply to all archives in the repository unless you restrict its operation to a subset of the archives using --prefix. When using --prefix, be careful to choose a good prefix - e.g. do not use a prefix "foo" if you do not also want to match "foobar".

It is strongly recommended to always run prune -v --list --dry-run ... first so you will see what it would do without it actually doing anything.

There is also a visualized prune example in docs/misc/prune-example.txt.

# Keep 7 end of day and 4 additional end of week archives.
# Do a dry-run without actually deleting anything.
$ borg prune -v --list --dry-run --keep-daily=7 --keep-weekly=4 /path/to/repo
# Same as above but only apply to archive names starting with the hostname
# of the machine followed by a "-" character:
$ borg prune -v --list --keep-daily=7 --keep-weekly=4 --prefix='{hostname}-' /path/to/repo
# Keep 7 end of day, 4 additional end of week archives,
# and an end of month archive for every month:
$ borg prune -v --list --keep-daily=7 --keep-weekly=4 --keep-monthly=-1 /path/to/repo
# Keep all backups in the last 10 days, 4 additional end of week archives,
# and an end of month archive for every month:
$ borg prune -v --list --keep-within=10d --keep-weekly=4 --keep-monthly=-1 /path/to/repo

SEE ALSO

borg-common(1)

AUTHOR
The Borg Collective